<%

def time_difference(time)
  difference = Time.now - Time.parse(time)
  parts = ActiveSupport::Duration.build(difference).parts.first
  "#{parts.last} #{(parts.last == 1 ? parts.first.to_s.chop : parts.first)} ago"
end

def current_output
   out = []
   out.push('| Issue | Summary | Status | Labels | Assignee | Created | Updated |')
   out.push('|:-----:|---------|:------:|--------|----------|---------|---------|')
   @current.each do |issue|
     string =  "| [#{issue['iid']}](#{issue['web_url']}) "
     string += "| #{issue['title']} "
     string += "| #{issue['state']} "
     string += "| #{issue['labels'].map { |l| "~\"#{l}\"" }.join(' <br /> ')} "
     string += "| #{issue['assignees'].map { |a| "#{a['username']}" }.join(' ')} "
     string += "| #{time_difference(issue['created_at'])} "
     string += "| #{time_difference(issue['updated_at'])} |"
     out.push(string)
   end
   out.join("\n")
end

def outstanding_output
  out = []
  out.push('| Issue | Summary | Labels | Assignee | Created | Updated |')
  out.push('|:-----:|---------|--------|----------|---------|---------|')
  @outstanding.each do |issue|
    string =  "| [#{issue['iid']}](#{issue['web_url']}) "
    string += "| #{issue['title']} "
    string += "| #{issue['labels'].map { |l| "~\"#{l}\"" }.join(' <br /> ')} "
    string += "| #{issue['assignees'].map { |a| "@#{a['username']}" }.join(' ')} "
    string += "| #{time_difference(issue['created_at'])} "
    string += "| #{time_difference(issue['updated_at'])} |"
    out.push(string)
  end
  out.join("\n")
end

@current = current_issues
@outstanding = outstanding_issues

%>
## Dotcom Escalations Weekly Report

### Issues Opened This Period:
<% if @current.count.zero? %>
Zero Dotcom Escalations opened this week!
<% else %>
<%= current_output %>
<% end %>
### Outstanding Issues:
<% if @outstanding.count.zero? %>
Zero outstanding Dotcom Escalations!
<% else %>
<%= outstanding_output %>
<% end %>

#### Everyone can contribute!

[View source code](https://gitlab.com/gitlab-com/support/toolbox/dewr) or
[File an issue!](https://gitlab.com/gitlab-com/support/toolbox/dewr/-/issues)
/label ~DEWR
